AkimboWeaponBase = AkimboWeaponBase or class(NewRaycastWeaponBase)
AkimboWeaponBase.AKIMBO = true
function AkimboWeaponBase:init(...)
	AkimboWeaponBase.super.init(self, ...)
	self._manual_fire_second_gun = self:weapon_tweak_data().manual_fire_second_gun
end


function AkimboWeaponBase:_create_second_gun(unit_name)
	local factory_weapon = tweak_data.weapon.factory[self._factory_id]
	local ids_unit_name = Idstring(factory_weapon.unit)
	local new_unit = World:spawn_unit(ids_unit_name, Vector3(), Rotation())
	new_unit:base():set_factory_data(self._factory_id)
	if self._cosmetics_id then
		new_unit:base():set_cosmetics_data({
			id = self._cosmetics_id,
			quality = self._cosmetics_quality,
			bonus = self._cosmetics_bonus
		})
	end
	if self._blueprint then
		new_unit:base():assemble_from_blueprint(self._factory_id, self._blueprint)
	elseif not unit_name then
		new_unit:base():assemble(self._factory_id)
	end
	self._second_gun = new_unit
	self._second_gun:base().SKIP_AMMO = true
	self._second_gun:base().parent_weapon = self._unit
	new_unit:base():setup(self._setup)
	if self._enabled then
		self._second_gun:base():on_enabled()
	else
		self._second_gun:base():on_disabled()
	end
end
function AkimboWeaponBase:toggle_firemode(skip_post_event)
	if AkimboWeaponBase.super.toggle_firemode(self, skip_post_event) then
		if alive(self._second_gun) then
			return self._second_gun:base():toggle_firemode(true)
		else
			return true
		end
	end
	return false
end

function AkimboWeaponBase:create_second_gun(create_second_gun)
	if managers.player:player_unit():inventory():akimbo_shield_enabled() then
		self._blueprint = {
		"wpn_fps_shield_body_akimbo",
		"wpn_fps_upg_fl_pis_crimson",
		"wpn_fps_upg_fl_ass_utg",
		"wpn_fps_upg_fl_ass_laser",
		"wpn_fps_upg_fl_ass_peq15",
		"wpn_fps_upg_fl_pis_x400v"
		}
	end	
	self:_create_second_gun(create_second_gun)
	self._setup.user_unit:camera()._camera_unit:link(Idstring("a_weapon_left"), self._second_gun, self._second_gun:orientation_object():name())
end


function AkimboWeaponBase:_fire_second(params)
	if alive(self._second_gun) and self._setup and alive(self._setup.user_unit) and not managers.player:player_unit():inventory():akimbo_shield_enabled() then
		local fired = self._second_gun:base().super.fire(self._second_gun:base(), unpack(params))
		if fired then
			if self._fire_second_sound then
				self._fire_second_sound = false
				self._second_gun:base():_fire_sound()
			end
			managers.hud:set_ammo_amount(self:selection_index(), self:ammo_info())
			self._second_gun:base():tweak_data_anim_play("fire")
		end
		return fired
	end
end

function AkimboWeaponBase:set_gadget_on(...)
	AkimboWeaponBase.super.set_gadget_on(self, ...)
	if alive(self._second_gun) and not managers.player:player_unit():inventory():akimbo_shield_enabled() then
		self._second_gun:base():set_gadget_on(...)
	end
end