local _hts_PlayerInventory_init = PlayerInventory.init

function PlayerInventory:init(...)
	_hts_PlayerInventory_init(self, ...)
	self._shield_unit = nil
	self.akimbo_shield_enabler = false
end

local _hts_PlayerInventory_place_selection = PlayerInventory._place_selection

function PlayerInventory:_place_selection(selection_index, is_equip)
	_hts_PlayerInventory_place_selection(self, selection_index, is_equip)
	if not self:is_this_able_to_shield() then
		return
	end
	if is_equip then
		self:give_shield()
	else
		self:hide_shield()
	end
end

function PlayerInventory:get_shield_unit()
	return self._shield_unit
end

function PlayerInventory:check_shield_unit()
	return self._shield_unit and alive(self._shield_unit) and true or false
end

function PlayerInventory:give_shield()
	if not self:is_this_able_to_shield() then
		return
	end
	
	self:hide_shield()
	local _shield = "units/payday2/characters/ene_acc_shield_lights/ene_acc_shield_lights"

	local selection = self._available_selections[self._equipped_selection]
	if not selection then
		return
	end
	local weapon_unit = selection.unit
	local factory_id = weapon_unit:base()._factory_id
	local weapon_id = managers.weapon_factory:get_weapon_id_by_factory_id(factory_id)
	if (weapon_id ~= "predatorshield") and (weapon_id ~= "predatorshield_secondary") then
		local equipped_primariy = managers.blackmarket:equipped_primary()
		local equipped_secondary = managers.blackmarket:equipped_secondary()
		log(tostring("category"))
		log(tostring(tweak_data.weapon[equipped_primariy.weapon_id].category)) 
		if tweak_data.weapon[equipped_primariy.weapon_id].category ~= "akimbo" or equipped_secondary.weapon_id ~= "predatorshield_secondary" then
			return
		end	
	end
	self.akimbo_shield_enabler = true
	local weap_align_data = selection.use_data["equip"]
	local align_place = self._align_places[weap_align_data.align_place]
	--local _camera_unit = self._unit:camera()._camera_unit
	--local cam_rot = _camera_unit:rotation()
	--local cam_pos = _camera_unit:position()
	self._shield_unit = World:spawn_unit(Idstring(_shield), Vector3(), Rotation())
	--self:_link_weapon(self._shield_unit, {obj3d_name = Idstring("a_weapon_left"), on_body = false})

	for i = 0, self._shield_unit:num_bodies() - 1 do
		self._shield_unit:body(i):set_keyframed(false)
		self._shield_unit:body(i):set_enabled(false)
	end -- Disabled FBI shield collision

end

function PlayerInventory:hide_shield()
	if not self:is_this_able_to_shield() then
		return
	end
	if self._shield_unit and alive(self._shield_unit) then
		self._shield_unit:unlink()
		World:delete_unit(self._shield_unit)
	end
end

function PlayerInventory:is_this_able_to_shield()
	local peer = managers.network:session():peer_by_unit(self._unit)
	if peer and peer == managers.network:session():local_peer() then
		return true
	end
	return false
end

function PlayerInventory:akimbo_shield_enabled()
	if self.akimbo_shield_enabler == true then
		log(tostring("akimbo_shield_enabled_true"))
		return true
	end
	return false
end

